/*
  Ex8_5
  Build a doubly linked list.
*/
struct entry
{
    int          value;
    struct entry *last;
    struct entry *next;
};

void display(top)
struct entry *top;   /* start of list */
{
    struct entry *end=top;

    printf("Element in the list are (as follow) :\n");
    while (top) 
    {
        printf("%6d",top->value);
        if (top->next == 0) 
            end=top;
        top=top->next;
    }
    printf("\n");
    printf("---Print the list in the contraty order :\n");
    while ( end && end->last ) 
    {
	printf("%6d",end->value);
	end=end->last;
    }
    printf("\n\n");
}

void insert_entry(pre_ptr,ptr)
struct entry *pre_ptr;   /* pointer of previous item  */
struct entry *ptr;       /* pointer of item to insert */
{
    ptr->next=pre_ptr->next;
    pre_ptr->next=ptr;
    ptr->last=pre_ptr;
    if (ptr->next) ptr->next->last=ptr;
}

main()
{
    struct entry n1,n2,n3,n4,list_head;   /* items of list */

    /* initialize the item */
    n1.value=100;
    n2.value=200;
    n3.value=300;
    n4.value=400;
    n1.next =0;
    n1.last =0;
    list_head.last=0;
    list_head.next= &n1;

    /* insert each item into list */
    insert_entry(&list_head,&n2);
    insert_entry(&n1,&n3);
    insert_entry(&n2,&n4);

    display(list_head.next);

}
